// DISPLAY2.CPP - display dispatcher

//                Step #2 to object oriented programming.
//                Uses lists of pointers to objects and
//                down casts to service list.

// Jim Fawcett, CST 2-127, (315)443-4454


#include "slist.hpp"   // declarations for generic singly linked list

struct point {         // coordinates on graphic screen
  int x;
  int y;
  point(int newx, int newy) : x(newx), y(newy) { }
  point() : x(0), y(0) { }
  point& operator()(int xin, int yin) { x=xin; y=yin; return *this; }
  point& operator=(point& p)          { x=p.x; y=p.y; return *this; }
};

class DisplayObj {     // base class for graphics objects
		       // establishes facilities shared by
		       // and tailored for each of the objects
  private:
    point position;

  public:
    DisplayObj() { position.x = position.y = 0; }
    DisplayObj(point p) { position = p;}
    virtual ~DisplayObj() { }
};

class LabeledObj : public DisplayObj {   // objects with labels
  private:
    char *label;
  public:
    LabeledObj() { }
    LabeledObj(point p) : DisplayObj(p) { };
    ~LabeledObj() { }
    void addLabel(void) { cout << "labeling lobject\n"; }
};

class unLabeledObj : public DisplayObj { // objects without labels
  public:
    unLabeledObj() { }
    unLabeledObj(point p) : DisplayObj(p) { };
    ~unLabeledObj() { };
};
/**/
void main() {  //---- display dispatcher ----------------------

  cout << "\nTesting Display List Dispatcher\n\n";
  slist<DisplayObj*> displayList;  // Create list of pointers
				   // for graphics objects.

// create graphics objects
    LabeledObj  lo1,  lo2;
  unLabeledObj ulo1, ulo2;

// create a list of pointers to the objects
  displayList.insert(0, &lo1);
  displayList.insert(1,&ulo1);
  displayList.insert(2, &lo2);
  displayList.insert(3,&ulo2);

// Now label the graphics objects - uses down cast!!!
  cout << "\nadding labels to objects in display list\n";
  for (int i=0; i<displayList.listLength(); i++)
    ((LabeledObj*)displayList[i])->addLabel();
	 // semantic error: addlabel() not member of unLabeled obj
	 //                 cast gives erroneous results
}
